<?php
/* 
 * --------------------------------------------------------------
 * patworx multimedia GmbH
 * http://www.patworx.de
 * Copyright (c) 2014 patworx multimedia GmbH
 * Released under the GNU General Public License (Version 2)
 * [http://www.gnu.org/licenses/gpl-2.0.html]
 * 
 */

if (!function_exists('xtc_get_country_name'))
	require_once(DIR_FS_INC . 'xtc_get_country_name.inc.php');
if (!function_exists('xtc_validate_email'))
	require_once(DIR_FS_INC . 'xtc_validate_email.inc.php');

class cleverreach_api {

  public $order_id = false;

  protected $nlListId = 0;
  
  private $maxPages = 10000; // 100 recipients per page... 
  private $usersource = 'GX2';
  private $soapEndpoint = "http://api.cleverreach.com/soap/interface_v5.1.php?wsdl";	
		
  public function __construct(){
  	if (defined('cleverreach_nl_list_id'))
  		$this->nlListId = constant('cleverreach_nl_list_id');
  }  
  
  public static function fromCron($email, $action, $directSync) {
  	self::fromNewsletterScript($email, $action, $directSync);
  }
  
  public static function fromNewsletterScript($email, $action, $directSync = true) {
  	if (defined('cleverreach_active') && constant('cleverreach_active') == 'true') {
	  	$customers_id = false;
	  	$customer_check = xtc_db_query("SELECT customers_id FROM customers WHERE customers_email_address = '" . xtc_db_input($email) . "'");
	  	if (xtc_db_num_rows($customer_check)) {
	  		$customers_result = xtc_db_fetch_array($customer_check);
	  		$customers_id = $customers_result['customers_id'];
	  	}
	  	if ($action == 'ADD')
	  		$id = self::subscribeToSync($customers_id, $email);
	  	else
	  		$id = self::unsubscribeToSync($customers_id, $email);
	  	
	  	if ($directSync)
	  		self::directSync($id);  	
  	}
  }  
  
  
  protected static function subscribeToSync($customers_id = false, $email) {
  	xtc_db_perform('cleverreach_api_sync', array('customers_id' => (int)$customers_id, 
  												 'email' => $email,
  												 'action' => 'ADD', 
  												 'created_at' => 'now()'));
  	return xtc_db_insert_id();
  }
  
  protected static function unsubscribeToSync($customers_id = false, $email) {
  	xtc_db_perform('cleverreach_api_sync', array('customers_id' => (int)$customers_id, 
  												 'email' => $email,
  												 'action' => 'DEL', 
  												 'created_at' => 'now()'));
  	return xtc_db_insert_id();
  }
  
  public static function directSync($id) {
  	if (defined('cleverreach_active') && constant('cleverreach_active') == 'true') {
	  	$tmp = new self();
	  	$tmp->localToRemoteSync($id);
  	}
  }
  
  
  public function localToRemoteSync($id = false) {
  	
  	if (defined('cleverreach_active') && constant('cleverreach_active') == 'true') {
	  	  	
		$export = new SoapClient($this->soapEndpoint);
		
		if ($id)
	  		$qry = xtc_db_query("SELECT * FROM `cleverreach_api_sync` WHERE status = '0' AND action = 'ADD' AND id = '" . $id . "'");
		else
			$qry = xtc_db_query("SELECT * FROM `cleverreach_api_sync` WHERE status = '0' AND action = 'ADD'");
		
		$user = array();		
		$crApiSyncUserIDs = array();
	  	while ($r = xtc_db_fetch_array($qry)) {  		
			$attributes = array();
			if ($r['customers_id'] > 0) {
				
				$customerData = xtc_db_query("SELECT c.*, ab.* 
												FROM customers c 
										   LEFT JOIN address_book ab ON ab.address_book_id = c.customers_default_address_id");
				$customersDataResult = xtc_db_fetch_array($customerData);
				
				$country = xtc_get_country_name($customersDataResult["customers_country"]);
				
	     		$attributes = array(
	        						0 => array("key" => "firstname", "value" =>  utf8_encode($customersDataResult["customers_firstname"])),
	         						1 => array("key" => "lastname", "value" => utf8_encode($customersDataResult["customers_lastname"])),
			 						2 => array("key" => "street", "value" => utf8_encode($customersDataResult["entry_street_address"])),
			 						3 => array("key" => "zip", "value" => utf8_encode($customersDataResult["entry_postcode"])),
			 						4 => array("key" => "city", "value" => utf8_encode($customersDataResult["entry_city"])),
			 						5 => array("key" => "country", "value" => utf8_encode($country)),
			 						6 => array("key" => "company", "value" => utf8_encode($customersDataResult["entry_company"]))
									);			
			}
			
			$user[] = array(
							"salutation" =>  "",
	     					"email" => $r["email"],
		 					'source' => $this->usersource, 
	     					"attributes" => $attributes,  
							"orders" => array());
			
			$crApiSyncUserIDs[] = $r['id'];
			
			if (sizeof($user) > 49) {
				$export->receiverAddBatch(constant('cleverreach_api_key'), $this->nlListId, $user);
					
				xtc_db_perform('cleverreach_api_sync', array('status' => '1',
															 'updated_at' => 'now()'), 'update', "id IN (" . join(",", $crApiSyncUserIDs) . ")");
				 
				$user = array();
				$crApiSyncUserIDs = array();				 
			}			
			
	  	}
	  	if (sizeof($user) > 0) {
	  		$export->receiverAddBatch(constant('cleverreach_api_key'), $this->nlListId, $user);
	  		  		
	  		xtc_db_perform('cleverreach_api_sync', array('status' => '1',
	  													 'updated_at' => 'now()'), 'update', "id IN (" . join(",", $crApiSyncUserIDs) . ")");
	  		
	  		
	  	}
	  	
	  	if ($id)
	  		$qry = xtc_db_query("SELECT * FROM `cleverreach_api_sync` WHERE status = '0' AND action = 'DEL' AND id = '" . $id . "'");
	  	else
	  		$qry = xtc_db_query("SELECT * FROM `cleverreach_api_sync` WHERE status = '0' AND action = 'DEL'");
	  	  	
	  	while ($r = xtc_db_fetch_array($qry)) {
	  		$export->receiverDelete(constant('cleverreach_api_key'), $this->nlListId, $r["email"]);  	
	  		xtc_db_perform('cleverreach_api_sync', array('status' => '1',
	  													 'updated_at' => 'now()'), 'update', "id='" . (int)$r['id'] . "'");
	  	}
  	}
  }
      
  public function completeSync() {
	  
	ini_set('max_execution_time', 900);
	ini_set('memory_limit', '512M'); 
	
  	$soap = new SoapClient($this->soapEndpoint);
  	
  	$abonnenten_local = array();
  	$abonnenten_remote = array(); 
  	
  	$page = 0;
  	do {
  		$filter = array( "page"=>$page++,
  						 "filter"=>"active");
  		$return = $soap->receiverGetPage(constant('cleverreach_api_key'), $this->nlListId, $filter);
  		if ($return->status=="SUCCESS") {  			
  			foreach ($return->data as $obj) {
  				$abonnenten_remote[] = strtolower((string)$obj->email); 
  			}  			
  		} else {  			
  		}
  		if($page >= $this->maxPages) break;    
  	} while ($return->data);
  	
  	
  	$customers = xtc_db_query("SELECT customers_email_address FROM customers WHERE customers_newsletter = '1'");
  	while ($customer = xtc_db_fetch_array($customers)) {
  		$abonnenten_local[] = trim(strtolower($customer['customers_email_address']));
  	}
  	
  	$newsletter_recipients = xtc_db_query("SELECT customers_email_address FROM newsletter_recipients WHERE mail_status = '1'");
  	while ($newsletter_recipient = xtc_db_fetch_array($newsletter_recipients)) {
  		if (!in_array(trim(strtolower($newsletter_recipient['customers_email_address'])), $abonnenten_local))
  			$abonnenten_local[] = trim(strtolower($newsletter_recipient['customers_email_address']));
  	}
  	
  	$to_activate = array();
  	$to_deactivate = array();
  	
  	if (strtolower(constant('cleverreach_prio')) == 'webshop') {
	  	foreach ($abonnenten_local as $al) {
  			if (!in_array($al, $abonnenten_remote))
  				$to_activate[] = $al;
  		}
  		foreach ($abonnenten_remote as $ar) {
  			if (!in_array($ar, $abonnenten_local))
  				$to_deactivate[] = $ar;
  		}  		
  		// Webshop > CR
  		// In Shop, nicht in CR -> activate 
  		// In CR, nicht in Shop -> deactivate 
  		
  		foreach ($to_activate as $ta) {
  			if (xtc_validate_email($ta))
	  			self::fromCron($ta, 'ADD', false);
  		}
  		foreach ($to_deactivate as $td) {
  			if (xtc_validate_email($td))
  				self::fromCron($td, 'DEL', false);
  		}
  		
  	} else if (strtolower(constant('cleverreach_prio')) == 'cleverreach') {  	
  		foreach ($abonnenten_remote as $ar) {
  			if (!in_array($ar, $abonnenten_local))
  				$to_activate[] = $ar;
  		}  
  		foreach ($abonnenten_local as $al) {
  			if (!in_array($al, $abonnenten_remote))
  				$to_deactivate[] = $al;
  		}		
  		// CR > Webshop
  		// In CR, nicht in Shop -> active in Shop
  		// In Shop, nicht in CR -> deactivate in Shop 
  		
  		foreach ($to_activate as $ta) {
  			$customers_info = false;  		
  			$customer_check = xtc_db_query("SELECT customers_id, customers_status, customers_firstname, customers_lastname FROM customers WHERE LOWER(customers_email_address) = '" . xtc_db_input($ta) . "'");
  			if (xtc_db_num_rows($customer_check)) {
  				$customers_info = xtc_db_fetch_array($customer_check);
  			}  			
  			
  			xtc_db_query("UPDATE customers SET customers_newsletter = '1' WHERE LOWER(customers_email_address) = '" . xtc_db_input($ta) . "'");
  			$newsletter_recipient_query = xtc_db_query("SELECT mail_id FROM newsletter_recipients WHERE LOWER(customers_email_address) = '" . xtc_db_input($ta) . "'"); 			
  			if (!xtc_db_num_rows($newsletter_recipient_query)) {
  				$data = array();
  				if ($customers_info) {
  					$data = array('customers_id' => $customers_info['customers_id'], 
  								  'customers_status' => $customers_info['customers_status'],
  								  'customers_firstname' => $customers_info['customers_firstname'],
  								  'customers_lastname' => $customers_info['customers_lastname']);
  				} else {
  					$data['customers_status'] = DEFAULT_CUSTOMERS_STATUS_ID;
  				}
  				$data['customers_email_address'] = $ta;
  				$data['mail_status'] = 1;
  				$data['mail_key'] = 'IMPORT_CLEVERREACH';
  				$data['date_added'] = 'now()';
  				
  				xtc_db_perform('newsletter_recipients', $data);
  			} else {
  				xtc_db_query("UPDATE newsletter_recipients SET mail_status = '1' WHERE LOWER(customers_email_address) = '" . xtc_db_input($ta) . "'");
  			}
  		}
  		foreach ($to_deactivate as $td) {
  			xtc_db_query("UPDATE customers SET customers_newsletter = '0' WHERE LOWER(customers_email_address) = '" . xtc_db_input($td) . "'");
  			xtc_db_query("UPDATE newsletter_recipients SET mail_status = '0' WHERE LOWER(customers_email_address) = '" . xtc_db_input($td) . "'");
  		}  		
  		
  	}
  	  	
  	$this->localToRemoteSync();
  	
  	
  }
  
  
  
  
 
}
?>